/*
 * The canvas which draws the network.
 */

import java.lang.*;
import java.awt.*;
import java.applet.*;
//import java.awt.event.*;
import java.util.*;
import java.io.*;

import Node;
import Link;
import TraficClass;
import SimpleDialog;
import TripleDialog;

public class NetCanvas extends Canvas 
/* implements MouseListener, MouseMotionListener */ {
  
  /* The label where to put messages */
  Label m_msgLabel;

  /* the nodes in the network */
  Vector m_vNodes;
  
  /* the links in the network */
  Vector m_vLinks;
  
  /* the classes */
  Vector m_vClasses;
  
  /* internal used variables */
  Node m_crtNode ;
  Node m_pointedNode;
  boolean m_bPointingClass;
  boolean m_bPointingLink;

  TripleDialog m_td;
  public NetCanvas( Label msglabel ) {
    /* Set the message label */
    m_msgLabel = msglabel;

    m_vNodes = new Vector();
    m_vClasses = new Vector();
    m_vLinks = new Vector();
    
    /* Initialize the internals */
    m_crtNode = null;
    m_pointedNode = null;
    m_bPointingClass = false;
    m_bPointingLink = false;

    /* set the colors .. */
    setBackground( Color.white );
    setForeground( Color.blue );

    // addMouseListener(this); 
    // addMouseMotionListener(this);

    /* continue .. */
    Object findFrame = msglabel.getParent();
    while( !(findFrame instanceof Frame ) )
      findFrame = (( Component )findFrame ).getParent();

    m_td = new TripleDialog( ( Frame ) findFrame, "" );
  }

  /** Grr.. hard coded.. anyway.. nobody's looking.. **/
  //  public Dimension getMinimumSize() {
  //    return new Dimension( 500, 300 );
  //  }
  //  public Dimension getPreferredSize() {
  //    return new Dimension( 500, 300 );
  //  }

  /* The most importan method - paint .. */
  public void paint(Graphics g) {
    /* First paint the links .. */
    for( int nIndex = 0; nIndex < m_vLinks.size(); nIndex ++ ) 
      (( Link ) m_vLinks.elementAt( nIndex )).paintLink( g );

    /* First paint the nodes .. */
    for( int nIndex = 0; nIndex < m_vNodes.size(); nIndex ++ ) 
      (( Node ) m_vNodes.elementAt( nIndex )).paintNode( g, nIndex );
  }

  /* helper function, to see if the current position is on a node */
  Node getNodeAt( int X, int Y ) {
    for( int nIndex = 0; nIndex < m_vNodes.size(); nIndex ++ ) {
      Node crt = ( Node ) m_vNodes.elementAt( nIndex );
      if( crt.isInside( X, Y ))
	return crt;
    }
    return null;
  }

  /* helper function, to see if the current position is on a link */
  Link getLinkAt( int X, int Y ) {
    for( int nIndex = 0; nIndex < m_vLinks.size(); nIndex ++ ) {
      Link crt = ( Link ) m_vLinks.elementAt( nIndex );
      if( crt.isInside( X, Y ))
	return crt;
    }
    return null;
  }

  /* Now, if the user press the button down .. */
  //  public void mouseClicked(MouseEvent e) {
  public boolean  mouseDown( Event e, int X, int Y ) {
    // m_crtNode = getNodeAt( e.getX(), e.getY() );
    m_crtNode = getNodeAt( X, Y );
   
    int nCounts = e.clickCount; //  e.getClickCount();

    if( nCounts > 1 ) {
      /* Add / delete */
      // if( ( e.getModifiers() & InputEvent.BUTTON2_MASK ) == 0 )
      if( ( e.modifiers & Event.META_MASK ) == 0 )
	/* now, add a node */
	AddNode( X, Y ); // e.getX() , e.getY() );
      else 
	/* Delete a node */
	DeleteNode( X, Y ); // e.getX(), e.getY() );
    }
    /* Want to define a class or a link.. see what's happening */
    else {
      if( m_crtNode == null ) {
	m_pointedNode = null;
	m_bPointingClass = false;
	m_bPointingLink = false;
      }
      else {
	/* Is a link or a class */
	// if( ( e.getModifiers() & InputEvent.SHIFT_MASK ) != 0 ) {
	if( ( e.modifiers & Event.SHIFT_MASK ) != 0 ) {
	  /* is a class ... */
	  if( m_bPointingClass ) {
	    AddClass( m_crtNode, m_pointedNode );
	    m_pointedNode = null;
	    m_bPointingClass = false;
	  }
	  else {
	    m_pointedNode = m_crtNode;
	    m_bPointingClass = true;
	    m_bPointingLink = false;
	  }
	}
	// else if( ( e.getModifiers() & InputEvent.CTRL_MASK ) != 0 ) {
	else if( ( e.modifiers & Event.CTRL_MASK ) != 0 ) {
	  /* is a link ... */
	  if( m_bPointingLink ) {
	    AddLink( m_crtNode, m_pointedNode );
	    m_pointedNode = null;
	    m_bPointingLink = false;
	  }
	  else {
	    m_pointedNode = m_crtNode;
	    m_bPointingClass = false;
	    m_bPointingLink = true;
	  }
	}
      } /* end else m_crtNode = null */
    } /* end else doubl click */

    //
    return false;
  }

  /* now, mouse have been pressed .. */
  // public void mousePressed(MouseEvent e) {
  //  m_crtNode = getNodeAt( e.getX(), e.getY() );
  // }
   
  /* now, mouse have been dragged - move the crt node */
  // public void mouseDragged(MouseEvent e) {
  public boolean mouseDrag( Event e, int X, int Y) {
    if( null != m_crtNode  ) {
      /* Get the current mouse position */
      int xPos = X; // e.getX();
      int yPos = Y; // e.getY();

      /* Regularize them */
      if( xPos < 0 ) xPos = 0;
      if( yPos < 0 ) yPos = 0;
      if( xPos > size()/*getSize()*/.width ) xPos = size()/*getSize()*/.width;
      if( yPos > size()/*getSize()*/.height ) yPos = size()/*getSize()*/.height;

      m_crtNode.moveNode( xPos, yPos );
      repaint();
    }

    //
    return false;
  } 

  /* I also need to add this.. they require.. */
  // public void mouseReleased(MouseEvent e) { }
  // public void mouseEntered(MouseEvent e) { }
  // public void mouseExited(MouseEvent e) { }

  /* print some information.. if any .. */
  // public void mouseMoved(MouseEvent e) { 
  public boolean mouseMove(Event e, int X, int Y) {
    /* Some link here ... ? */
    Link link = getLinkAt( X, Y ); //e.getX(), e.getY() );
    if( null != link )
      m_msgLabel.setText( link.getInfoString() );
    else {
      /* Some node here ? */
      Node node = getNodeAt( X, Y ); //e.getX(), e.getY() );
      if( null != node ) {
	String str = new String();
	for( int nIndex = 0; nIndex < node. m_vClasses.size() ; nIndex ++ ) {
	  TraficClass tc = (( TraficClass ) node.m_vClasses.elementAt( nIndex));
	  
	  /* get the other node of the class */
	  int pairIndex;
	  if( tc.getNode1() == node )
	    pairIndex = m_vNodes.indexOf( tc.getNode2() );
	  else
	    pairIndex = m_vNodes.indexOf( tc.getNode1() );
	  
	  str += pairIndex + "-" + tc.getBandwidth() + 
	    "/"+tc.getLambda() + "/" +tc.getMiu() + "; ";
	}

	/* Display information about the classes */
	if( str.length() == 0 )
	  str = "No classes from / to this node.";
	else {
	  String auxString = new String( "Classes : " + str );
	  str = auxString;
	}

	m_msgLabel.setText( str );
      }
      else
	m_msgLabel.setText( "Drawing the net.." );
    }    

    // 
    return false;
  }
 

  /* this adds a link..  - by asking before about the capacity */
  void AddLink( Node node1, Node node2 ) {
    /* If I have the same node - just do nothing */
    if( node1 == node2 )
      return;

    /* Check if there is a link between node 1 and node 2 */
    for( int nIndex = 0; nIndex < node1.m_vLinks.size() ; nIndex ++ ) {
      Link link = ( Link )node1.m_vLinks.elementAt( nIndex );
      if( link.getNode1() == node2 || link.getNode2() == node2 ) {
	m_msgLabel.setText( "Already a link. Delete first the old one.." );
	return;
      }
    }
    
    /* Add a link .. */
    Object findFrame = getParent();
    while( !(findFrame instanceof Frame ) )
      findFrame = (( Component )findFrame).getParent();

    SimpleDialog sd = new SimpleDialog( ( Frame ) findFrame, "Enter the capacity:", 10 );
    sd.move/*setLocation*/( 100, 200 );
    sd.show();

    try {
      if( !sd.canceled && 
	  ( new Integer( sd.output ) ).intValue( ) > 0) {
	Link link = new Link( node1, node2,
			      ( new Integer( sd.output )).intValue( ) );
	
	node1.addLink( link );
	node2.addLink( link );
	m_vLinks.addElement( link );
	repaint();
      }
    }
    catch( Exception e ) {
    }
  }

 /* this adds a class  - by asking before about the required Capacity */
  void AddClass( Node node1, Node node2 ) {
    /* If I have the same node - just do nothing */
    if( node1 == node2 )
      return;

    boolean bSuccess = true;

    m_td.setTitle( "Enter data for classes from: " + 
		  m_vNodes.indexOf( node2 ) + " to " +
		  m_vNodes.indexOf( node1 ));
    m_td.canceled = false;
    /* add classesuntil the user finishes everything on that route */
    do {
      m_td.move/*setLocation*/( 100, 200 );
      m_td.show();
      
      try {
	
	if( !m_td.canceled && 
	    ( new Integer( m_td.output1 ) ).intValue( ) > 0 &&
	    ( new Double( m_td.output2 ) ).doubleValue( ) > 0 &&
	    ( new Double( m_td.output3 ) ).doubleValue( ) > 0 ) {
	  TraficClass traficClass = new TraficClass( node1, node2, 
						     ( new Integer( m_td.output1 ) ).intValue( ),
						     ( new Double( m_td.output2 ) ).doubleValue( ),
						     ( new Double( m_td.output3 ) ).doubleValue( ));
	  node1.addClass( traficClass );
	  node2.addClass( traficClass );
	  
	  m_vClasses.addElement( traficClass );
	}
	else 
	  bSuccess = false;
      }
      catch( Exception e ) {
      }
      
    } while( bSuccess );
  }
  
  /* This adds a new node */
  void AddNode( int X, int Y ) {
    Node newNode = new Node( X, Y );
    m_vNodes.addElement( newNode );
    repaint( );
  }
  /* This deletes a node */
  void DeleteNode( int X, int Y ) {
    Node delNode = getNodeAt( X, Y );
    if( null != delNode) {

      /* delete first all the classes */
      while( delNode.m_vClasses.size() > 0 ) {
	TraficClass tc = (( TraficClass ) delNode.m_vClasses.firstElement());
	tc.getNode1().deleteClass( tc );
	tc.getNode2().deleteClass( tc );
	m_vClasses.removeElement( tc );
      }

      /* delete all the links */
      while( delNode.m_vLinks.size() > 0 ) {
	Link lnk = (( Link )delNode.m_vLinks.firstElement());
	lnk.getNode1().deleteLink( lnk );
	lnk.getNode2().deleteLink( lnk );
	m_vLinks.removeElement( lnk );
      }

      /* delete the node */
      m_vNodes.removeElement( delNode );
      m_msgLabel.setText( "Node deleted OK !" );
      repaint();
    }
    
    /* Or some links .. */
    Link link = getLinkAt( X, Y );
    if( link != null ) {
      /* delete the link form it's nodes and from main list as well */
      link.getNode1().deleteLink( link );
      link.getNode2().deleteLink( link );
      m_vLinks.removeElement( link );

      /* Repaint and give the message */
      m_msgLabel.setText( "Link deleted OK !" );
      repaint();
    }

  }


  /* This will push the date in the output stream os */
  public void OutputNetConfig( OutputStream os, int nMethod) {
    String strBuffer;

    try {
      /* Write the method out */
      strBuffer = nMethod + " ";

      byte buffer[] = new byte[ strBuffer.length() ];
      strBuffer.getBytes( 0, strBuffer.length(), buffer, 0 ); 
      os.write( buffer );
      
      /* number of nodes first */
      strBuffer = m_vNodes.size() + " ";

      buffer = new byte[ strBuffer.length() ];
      strBuffer.getBytes( 0, strBuffer.length() , buffer, 0 ); 
      os.write( buffer );
      
      /* number of links */
      strBuffer = m_vLinks.size() + " ";

      buffer = new byte[ strBuffer.length() ];
      strBuffer.getBytes( 0, strBuffer.length(), buffer, 0 ); 
      os.write( buffer );

      /* Now the links themself */
      for( int nIndex = 0; nIndex < m_vLinks.size(); nIndex++ ) {
	Link link =  (( Link )m_vLinks.elementAt( nIndex ));
	strBuffer = m_vNodes.indexOf( link.getNode1() ) + " " +
	  m_vNodes.indexOf( link.getNode2() ) + " " +
	  link.getBandwidth() +" ";

	buffer = new byte[ strBuffer.length() ];
	strBuffer.getBytes( 0, strBuffer.length(), buffer, 0 ); 
	os.write( buffer );
      }
      
      /* number of classes */
      strBuffer = m_vClasses.size() + " ";

      buffer = new byte[ strBuffer.length() ];
      strBuffer.getBytes( 0, strBuffer.length(), buffer, 0 ); 
      os.write( buffer );
      
      /* Now the classess themself */
      for( int nIndex = 0; nIndex < m_vClasses.size(); nIndex++ ) {
	TraficClass tc = ( TraficClass )m_vClasses.elementAt( nIndex );
	strBuffer = m_vNodes.indexOf( tc.getNode1() ) + " " +
	            m_vNodes.indexOf( tc.getNode2() ) + " " +
	  tc.getBandwidth() + " " +
	  tc.getLambda() + " " +
	  tc.getMiu() + " ";

	buffer = new byte[ strBuffer.length() ];
	strBuffer.getBytes( 0, strBuffer.length(), buffer, 0 ); 
	os.write( buffer );
      }
      
      /* send a \0 */
      os.write( 0 );
    }
    catch( Exception e ) {
      m_msgLabel.setText( "Error sending message to server " );
      
    }
    /* this was .. */
  }
  
  /* this writes to an output file writer. No much 
     difference from befor.. but you know. */
  public void OutputNetConfigToFile( DataOutputStream out ) {
    try {
      /* number of nodes first */
      out.writeInt( m_vNodes.size() );
      /* Outputthe positions */
      for( int nIndex = 0; nIndex < m_vNodes.size(); nIndex++ ) {
	Node node = (( Node )m_vNodes.elementAt( nIndex ));
	out.writeInt( node.getX( ));
	out.writeInt( node.getY( ));
      }
     
      /* number of links */
      out.writeInt( m_vLinks.size() );

      /* Now the links themself */
      for( int nIndex = 0; nIndex < m_vLinks.size(); nIndex++ ) {
	Link link =  (( Link )m_vLinks.elementAt( nIndex ));
	out.writeInt( m_vNodes.indexOf( link.getNode1() ) );
	out.writeInt( m_vNodes.indexOf( link.getNode2() ) );
	out.writeInt( link.getBandwidth() );
      }
      
      /* number of classes */
      out.writeInt( m_vClasses.size() );

      /* Now the classess themself */
      for( int nIndex = 0; nIndex < m_vClasses.size(); nIndex++ ) {
	TraficClass tc = ( TraficClass )m_vClasses.elementAt( nIndex );
	out.writeInt( m_vNodes.indexOf( tc.getNode1() ) );
	out.writeInt( m_vNodes.indexOf( tc.getNode2() ) );
	out.writeInt( tc.getBandwidth() );
	out.writeDouble( tc.getLambda() );
	out.writeDouble( tc.getMiu() );
      }

    }
    catch( Exception e ) {
      m_msgLabel.setText( "Error while writeing to the output file" );
      
    }
    /* this was .. */
  }

  /* This  reads the stuff from the file */
  void InputNetConfigFromFile( DataInputStream in ) throws Exception {
   try {
     /* first empty all .. */
     m_vNodes.removeAllElements();
     m_vLinks.removeAllElements();
     m_vClasses.removeAllElements();

     /* number of nodes first */
     int nNodes = in.readInt();

     /* Outputthe positions */
     for( int nIndex = 0; nIndex < nNodes; nIndex++ ) {
       Node node = new Node( in.readInt(), in.readInt() );
       m_vNodes.addElement( node );
     }
     
     /* number of links */
     int nLinks = in.readInt();
     
     /* Now the links themself */
     for( int nIndex = 0; nIndex < nLinks; nIndex++ ) {
       int id1 = in.readInt( );
       int id2 = in.readInt( );
       if( id1 < 0 || id1 >= m_vNodes.size() ||
	   id2 < 0 || id2 >= m_vNodes.size()) {
	 throw( new Exception(" Invalid input " ));
       }
       Link link =  new Link( ( Node )m_vNodes.elementAt( id1 ),
			      ( Node )m_vNodes.elementAt( id2 ),
			      in.readInt() );
       (( Node ) m_vNodes.elementAt( id1 )).addLink( link );
       (( Node ) m_vNodes.elementAt( id2 )).addLink( link );
       
       m_vLinks.addElement( link );
     }
     
     /* number of classes */
     int nClasses = in.readInt();
     
     /* Now the classess themself */
     for( int nIndex = 0; nIndex < nClasses; nIndex++ ) {
       int id1 = in.readInt( );
       int id2 = in.readInt( );
       if( id1 < 0 || id1 >= m_vNodes.size() ||
	   id2 < 0 || id2 >= m_vNodes.size()) {
	 throw( new Exception(" Invalid input " ));
       }
       TraficClass tc =  new TraficClass( 
		     ( Node ) m_vNodes.elementAt( id1 ),
		     ( Node ) m_vNodes.elementAt( id2 ),
		     in.readInt(),
		     in.readDouble(),
		     in.readDouble() );
       m_vClasses.addElement( tc );

       (( Node ) m_vNodes.elementAt( id1 )).addClass( tc );
       (( Node ) m_vNodes.elementAt( id2 )).addClass( tc );

     }
   }
   catch( Exception e ) {
     m_vNodes.removeAllElements();
     m_vLinks.removeAllElements();
     m_vClasses.removeAllElements();
     m_msgLabel.setText( "Error while reading" +
			 e.toString( ));
      
     throw( e );
    }
    /* this was .. */
  }
  
}

