import java.lang.*;
import java.awt.*;
import java.applet.*;
// import java.awt.event.*;
import java.util.*;

public class Node extends Object {
  /* the placement of the node on the canvas */
  int m_nX, m_nY;

  /* the links from this node to the others */
  public Vector m_vLinks;
  
  /* the classes from this node to the others */
  public Vector m_vClasses;
  
  /* Some drawind constants */
  public final static int NODE_XDIM = 20;
  public final static int NODE_YDIM = 20;


  /* the constructor */
  public Node( int X, int Y ) {
    m_nX = X; m_nY = Y; 
    m_vLinks = new Vector();
    m_vClasses = new Vector();
  }

  /* this get the members */
  public int getX() { return m_nX; }
  public int getY() { return m_nY; }

  /* this will move the node to another position */
  public void moveNode( int newX, int newY ) {
    m_nX = newX; m_nY = newY;
  }
  
  /* Determine if a point is inside the node's circle.. */
  public boolean isInside( int X, int Y ) {
    return ( X > m_nX - NODE_XDIM / 2 && X < m_nX + NODE_XDIM / 2 &&
	     Y > m_nY - NODE_YDIM / 2 && Y < m_nY + NODE_YDIM / 2 );
  }

  /* the link manipulataion */
  public void addLink( Object newLink ) {
    m_vLinks.addElement( newLink );
  }  
  public void deleteLink( Object toDelete ) {
    m_vLinks.removeElement( toDelete );
  }

  /* the class manipulation */
  public void addClass( Object newClass ) {
    m_vClasses.addElement( newClass );
  }  
  public void deleteClass( Object toDelete ) {
    m_vClasses.removeElement( toDelete );
  }
  
  /* this will draw the node */
  public void paintNode( Graphics g, int id ) {
    g.setColor( Color.pink );
    g.fillOval( m_nX - NODE_XDIM / 2, m_nY - NODE_YDIM / 2, NODE_XDIM, NODE_YDIM );
    g.setColor( Color.red );
    g.drawOval( m_nX - NODE_XDIM / 2, m_nY - NODE_YDIM / 2, NODE_XDIM, NODE_YDIM );
    g.setColor( Color.black );
    String toPrint = ( new Integer( id )).toString();
    g.drawString( toPrint, 
		  m_nX - g.getFontMetrics().
		  charsWidth( toPrint.toCharArray(), 0, toPrint.length()) / 2 , 
		  m_nY + g.getFontMetrics().getAscent() / 2 );
  }

}
