/*
 *
 */
#include <stdio.h>
#include <errno.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/socket.h>
#include        <netinet/in.h>

#define ERR_SERVER_OK                0
#define ERR_SERVER_INPUT_TOO_LARGE  -1

#define N_CLIENTS  5

/* Some globals */

int glb_Newsockfd;
/* An input buffer - huge 16 K */
#define IN_BUFFER_LEN 16384
char glb_inBuffer[ IN_BUFFER_LEN ];

void main( int argc, char* argv[] ) {

  int nPort, sockfd;
  int clilen;
  struct sockaddr_in  cli_addr, serv_addr;
  
  char *ptr;
  int nRead, nLeft = IN_BUFFER_LEN;

  /*
   * Parse the input line 
   */
  if( argc < 2 ) 
    goto Usage;
  /* Get the port */
  nPort = atoi( argv[ 1 ] );
  if( nPort < 1 )
    goto Usage;

  /*
   * Open a TCP socket (an Internet stream socket).
   */
  if ( (sockfd = socket(AF_INET, SOCK_STREAM, 0)) < 0) {
    fprintf( stderr, "Error (%d): can't open stream socket\n", errno );
    exit( -1 );
  }

  /*
   * Bind our local address so that the client can send to us.
   */
  bzero((char *) &serv_addr, sizeof(serv_addr));
  serv_addr.sin_family      = AF_INET;
  serv_addr.sin_addr.s_addr = htonl(INADDR_ANY);
  serv_addr.sin_port        = htons( nPort );

  if (bind(sockfd, (struct sockaddr *) &serv_addr, sizeof(serv_addr)) < 0)
  {
    fprintf( stderr, "Error (%d): can't bind local address\n", errno);
    close( sockfd );
    exit( -1 );
  }

  printf( "Server is listening (TCP) at port %d\n" , nPort );
      

  /* listen for the number of clients.. */
  listen(sockfd, N_CLIENTS); 

  clilen = sizeof(cli_addr); 
  do { 
    glb_Newsockfd = accept(sockfd, (struct sockaddr *) &cli_addr, &clilen);
    if (glb_Newsockfd < 0) {
      fprintf( stderr, "Error (%d): accept error\n", errno);
      close( sockfd );
      exit( -1 );
    }
    
    /* Fork a new process.. */
    if( ! fork() ) { 
      /* in the child, read the data, make computations and submit the
       * response 
       */
      ptr = glb_inBuffer;

      /* Read the input  in the buffer */
      while (nLeft > 0) {
	nRead = read(glb_Newsockfd, ptr, IN_BUFFER_LEN);
	if (nRead < 0) {
	  /* error occured */
	  fprintf( stderr, "Error (%d): in reading input\n" );
	  return;
	}
	else if (nRead == 0 || ptr[ nRead - 1 ] == 0) {
	  /* Input - ready .. process it ! */

	  /*** No errors for now ***/
	  nRead = ERR_SERVER_OK;
	  /* write( glb_Newsockfd, &nRead, sizeof( int )); */
	  DoEvaluation();
	  
	  read( glb_Newsockfd, ptr, 1 );

	  return;
	}
	nLeft -= nRead;
	ptr   += nRead;
      }
      /* Input too large - print error and return error to the client */
      fprintf( stderr, "Error (): input is too large.\n" );
      
      nRead = ERR_SERVER_INPUT_TOO_LARGE;
      /*write( glb_Newsockfd, &nRead, sizeof( int ));*/

      return;
    }
  } while( 1 );


  close(sockfd);          /* close original socket */
  unlink( sockfd ); 

  return;

Usage:
  printf( "Bad usage.. \n" );

}
