#ifndef __STRUCTURES_MCMR_H
#define __STRUCTURES_MCMR_H

#ifdef _cplusplus
extern "C" {
#endif

#ifndef ESUCCESS
#define ESUCCESS    0
#endif

#ifndef TRUE
#define TRUE        1
#endif

#ifndef FALSE
#define FALSE       0
#endif

/*
 * This describes a Resource
 */
typedef struct tagRESOURCE {
  unsigned int m_nResourceID; 
  /* The ID of the ressource */

  double m_dCapacity;
  /* The utilization */
  double m_dUtilization;
  /* The capacity of the ressource */

  unsigned int m_nClasses;
  /* number of classes oin the ressource */
  struct tagCLASS** m_pClasses;
  /* The calsses themself */

  double** m_pdBlockingRes;
  /* The blocking probability at a ressource */

  double** m_pdZ;
  double** m_pdZOld;
  /* Auxiliarry internal values */

  double** m_pdRequired;
  /* the required amount per each class */

  double** m_pdServRate;
  /* the serving rate */

  double** m_pdN;
  double** m_pdNOld;
  /* number of active classes on ressource */

  unsigned int* m_pAssoc;
  /* the associations classes - Z / Z Old / Blocking */
} RESOURCE;

/*
 * This describes a class structure 
 */
typedef struct tagCLASS {
  unsigned int m_nClassID;
  /* The ID of the curent class */

  unsigned int m_nResources;
  /* The ressources to which it belongs to */
  RESOURCE** m_pResources;
  /* The ressources themself */

  double m_dArrRate;
  /* the arrival rate */

  double m_dServRate;
  unsigned int m_bSameRate;
  /* the serving rate just in case, if is only one..*/

  double m_dBlocking;
  /* The total blocking probability */
  double** m_pdBlockingRes;
  /* The blocking probability at a ressource */

  double m_dN;
  /* The number of connections of that class */
  double m_dNOld;
  /* The OLD  number of connections of that class */

  double** m_pdRequired;
  /* the required amount per each class */

  double** m_pdServRate;
  /* the serving rate */

  double** m_pdN;
  double** m_pdNOld;
  /* number of active classes on ressource */

  double** m_pdZ;
  double** m_pdZOld;
  /* Auxiliary internal values */
  unsigned int* m_pAssoc;
  /* the associations classes - Z / Z Old / Blocking */
  
  double m_dTotalAdmission;
  /* the total admission probability */
} CLASS;

/*
 * This is an event 
 */
typedef struct tagEVENT {
  int (*m_pCallback )( double, int, void * );
  /* what to call */
  int m_nParam;
  /* what integer to pass */
  void* m_pParam;
  /* what pointer to pass */

  int m_nID;
  /* the ID of the event */
  double m_dTime;
  /* when happens */

  struct tagEVENT* m_pNext;
} EVENT;

/*
 * the registered events / callbacks 
 */
extern EVENT** glb_pEventList;
extern unsigned int glb_nEvents;
extern unsigned int glb_nEventID;
/*
 * Global classes and ressources
 */
extern unsigned int glb_nClasses;
extern CLASS ** glb_pClasses;

extern unsigned int glb_nResources;
extern RESOURCE ** glb_pResources;

extern int ( *dumpFunction )( double, int, double **, double**, double, void* );
extern void* glb_pDumpParam;

#ifdef _cplusplus
  }
#endif

#endif /* __STRUCTURES_MCMR_H */
